Summary:   Experimental GNU Compiler System
Name:      pgcc
Version:   1.1a
Release:   1
Source:    %{name}-%{version}.tar.gz
URL:       http://www.gcc.ml.org
Copyright: GPL
Group:     Development/Languages
Requires:  binutils >= 2.8.1.0.15
Obsoletes: gcc
Provides:  gcc cpp
BuildRoot: /tmp/%{name}-%{version}-root

%description
A Pentium compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

%package   c++
Summary:   C++ support for gcc
Group:     Development/Languages
Requires:  %{name} = %{version}
Obsoletes: gcc-c++

%description c++
This package adds C++ support to the GNU C compiler. It includes support
for most of the current C++ specification, including templates and
exception handling. It does not include a standard C++ library, which
is available separately.

%package   objc
Summary:   Objective C support for gcc
Group:     Development/Languages
Requires:  %{name} = %{version}
Obsoletes: gcc-objc

%description objc
This package adds Objective C support to the GNU C compiler. Objective
C is a object oriented derivative of the C language, mainly used on
systems running NeXTSTEP. This package does not include the standard
objective C object library.

%package  g77
Summary:  Fortran 77 support for gcc
Group:    Development/Languages
Requires: %{name} = %{version}

%description g77
This apckage adds support for compiling Fortran 77 programs with the GNU
compiler.

%package libstdc++
Summary:   GNU c++ library
Group:     Libraries
Obsoletes: libg++

%description libstdc++
This is the GNU implementation of the standard C++ libraries. This 
package includes the shared libraries necessary to run C++ applications.

%package   libstdc++-devel
Summary:   Header files and libraries for C++ development
Group:     Development/Languages
Obsoletes: libg++-devel

%description libstdc++-devel
This is the GNU implementation of the standard C++ libraries.  This
package includes the header files and libraries needed for C++


%prep
%setup -q

%build
MACHINE=`uname -m`
rm -rf obj-$MACHINE-linux
mkdir obj-$MACHINE-linux
cd obj-$MACHINE-linux

%ifarch sparc
CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s \
../configure  --prefix=/usr \
              --enable-shared \
              --enable-haifa \
              --enable-threads \
              $MACHINE-linux-gnulibc1

%else

CFLAGS="$RPM_OPT_FLAGS" LDFLAGS=-s \
../configure  --prefix=/usr \
              --enable-shared \
              --enable-haifa \
              --enable-threads \
              $MACHINE-linux
%endif

PATH=$PATH:/sbin:/usr/sbin
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split" bootstrap-lean CFLAGS="$RPM_OPT_FLAGS" LIBCFLAGS="$RPM_OPT_FLAGS" LIBCXXFLAGS="$RPM_OPT_FLAGS "

%install
rm -rf $RPM_BUILD_ROOT
MACHINE=`uname -m`
cd obj-$MACHINE-linux
PATH=$PATH:/sbin:/usr/sbin
make prefix=$RPM_BUILD_ROOT/usr MAKEINFO="makeinfo --no-split" install
make prefix=$RPM_BUILD_ROOT/usr -C texinfo uninstall
FULLVER=`$RPM_BUILD_ROOT/usr/bin/$MACHINE-linux*-gcc --version | cut -d' ' -f1`
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/lib/gcc-lib/$MACHINE-*/$FULLVER/cc1)
strip $RPM_BUILD_ROOT/usr/bin/*

strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp,f771}

ln -sf g++ $RPM_BUILD_ROOT/usr/bin/c++
ln -sf gcc $RPM_BUILD_ROOT/usr/bin/cc

rm -f $RPM_BUILD_ROOT/usr/info/dir
gzip -n -9f $RPM_BUILD_ROOT/usr/info/*.info* 

ln -sf g77.1 $RPM_BUILD_ROOT/usr/man/man1/f77.1
ln -sf g77 $RPM_BUILD_ROOT/usr/bin/f77

install -d $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp $RPM_BUILD_ROOT/lib/cpp
mv $RPM_BUILD_ROOT/usr/lib/libiberty.a $FULLPATH

ln -sf cccp.1 $RPM_BUILD_ROOT/usr/man/man1/cpp.1

strip $RPM_BUILD_ROOT/usr/lib/libstdc++.so.*

%ifarch ppc
ln -sf libstdc++.so.*.* $RPM_BUILD_ROOT/usr/lib/nof/libstdc++.so.*.*
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/install-info \
	--section="Programming:" --entry="*gcc:(gcc).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/gcc.info.gz
/sbin/install-info \
	--section="Programming:" --entry="*cpp:(cpp).                   The C preprocessor." \
	--info-dir=/usr/info /usr/info/cpp.info.gz

%post g77 
/sbin/install-info \
	--section="Programming:" --entry="*g77:(g77).                     The GNU Fortran 77 compiler." \
	--info-dir=/usr/info /usr/info/g77.info.gz

%preun
if [ $1 = 0 ]; then
   /sbin/install-info --delete \
	--section="Programming:" --entry="*cpp:(cpp).                   The C preprocessor." \
	--info-dir=/usr/info /usr/info/cpp.info.gz
   /sbin/install-info --delete \
	--section="Programming:" --entry="*gcc:(gcc).                   The GNU C compiler." \
	--info-dir=/usr/info /usr/info/gcc.info.gz
fi

%preun g77
if [ $1 = 0 ]; then
   /sbin/install-info --delete \
	--section="Programming:" --entry="*g77:(g77).                     The GNU Fortran 77 compiler." \
	--info-dir=/usr/info /usr/info/g77.info.gz
fi

%files
%defattr(-,root,root)
%doc README* COPYING COPYING.LIB
%dir /usr/lib/gcc-lib
%dir /usr/lib/gcc-lib/*-linux*
%dir /usr/lib/gcc-lib/*-linux*/pgcc-*
%dir /usr/lib/gcc-lib/*-linux*/pgcc-*/include
/usr/bin/gcov
/usr/bin/protoize
/usr/bin/unprotoize
/usr/bin/gcc
/usr/bin/cc
%attr(-,root,man) /usr/man/man1/gcc.1
/usr/info/gcc*
/lib/cpp
%attr(-,root,man) /usr/man/man1/cpp.1
%attr(-,root,man) /usr/man/man1/cccp.1
/usr/info/cpp.info*.gz
/usr/lib/gcc-lib/*-linux*/pgcc-*/SYSCALLS.c.X
/usr/lib/gcc-lib/*-linux*/pgcc-*/cc1
/usr/lib/gcc-lib/*-linux*/pgcc-*/cpp
/usr/lib/gcc-lib/*-linux*/pgcc-*/libgcc.a
/usr/lib/gcc-lib/*-linux*/pgcc-*/specs
%ifnarch alpha
/usr/lib/gcc-lib/*-linux*/pgcc-*/*.o
%endif
%ifarch ppc
/usr/lib/gcc-lib/*-linux*/pgcc-*/nof
%endif
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/README
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/float.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/iso646.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/limits.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/proto.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/stdarg.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/stdbool.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/stddef.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/syslimits.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/va-*.h
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/varargs.h
%ifarch ppc
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/*-asm.h
%endif

%files c++
%defattr(-,root,root)
%attr(-,root,man) /usr/man/man1/g++.1
/usr/bin/g++
/usr/bin/c++
/usr/lib/gcc-lib/*-linux*/pgcc-*/cc1plus
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/exception
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/new
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/typeinfo
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/new.h
%ifarch ppc
/usr/lib/nof
%endif

%files objc
%defattr(-,root,root)
/usr/lib/gcc-lib/*-linux*/pgcc-*/collect2
/usr/lib/gcc-lib/*-linux*/pgcc-*/cc1obj
/usr/lib/gcc-lib/*-linux*/pgcc-*/libobjc.a
/usr/lib/gcc-lib/*-linux*/pgcc-*/libiberty.a
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/objc

%files g77
%defattr(-,root,root)
/usr/bin/g77
/usr/bin/f77
/usr/info/g77*
/usr/lib/gcc-lib/*-linux*/pgcc-*/f771
/usr/lib/gcc-lib/*-linux*/pgcc-*/libg2c.a
%attr(-,root,man) /usr/man/man1/g77.1
%attr(-,root,man) /usr/man/man1/f77.1
/usr/lib/gcc-lib/*-linux*/pgcc-*/include/g2c.h


%files libstdc++
%defattr(-,root,root)
/usr/lib/libstdc++.so.*
%ifarch ppc
/usr/lib/nof/libstdc++.so.*.*
%endif

%files libstdc++-devel
%defattr(-,root,root)
/usr/include/g++
/usr/lib/libstdc++.a
/usr/lib/libstdc++.so
%ifarch ppc
/usr/lib/nof/libstdc++.a
/usr/lib/nof/libstdc++.so
%endif

%changelog
* Wed Sep 02 1998 Binaire <binaire@binaire.ml.org>
- Updated to pgcc-1.1a

* Tue Sep 01 1998 Binaire <binaire@binaire.ml.org>
- Pre-release 1.1
- add libstdc++

* Sun May 31 1998 Arne Coucheron <arneco@online.no>
- released 1.0.3a-1
- using %%{name} and %%{version} macros
- added -q parameter to %setup
- using %defattr in %files to allow non-root users to build
- libstdc++ is not being packaged, newer versions are available as
  separate packages, so use them instead
- lots of changes to the spec file
